//+------------------------------------------------------------------+
//|                                                 SpreadLogger.mq4 |
//|                               Copyright 2014,Trade And Software. |
//|                                                 http://tasfx.net |
//+------------------------------------------------------------------+
#property copyright "Copyright 2014, Trade And Software."
#property link      "http://tasfx.net"
#property version   "1.1.0"
#property strict
#property indicator_chart_window
//--- input parameters
input int      FontSize=12;
input color    FontColor=clrAqua;
input bool     Logging=true;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int OnInit()
  {
//--- indicator buffers mapping
   ObjectCreate("SpreadLabel", OBJ_LABEL, 0, 0, 0);
   ObjectSet("SpreadLabel", OBJPROP_CORNER, 1);
   ObjectSet("SpreadLabel", OBJPROP_XDISTANCE, 10);
   ObjectSet("SpreadLabel", OBJPROP_YDISTANCE, 15);
//---
   return(INIT_SUCCEEDED);
  }

void OnDeinit(const int reason)
   {
      ObjectDelete("SpreadLabel");
   }
  
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])
  {
//---
   int digit = Digits;
   if(digit == 3 || digit == 5)
   {
      digit -= 1;
   }
   
   double spreadTemp = (Ask - Bid) * MathPow(10,digit);
   string spreadValue = DoubleToStr(spreadTemp, 1);
   ObjectSetText("SpreadLabel", spreadValue, FontSize, "Arial", FontColor);
   
   string periodChar = "";
   string pair = Symbol();
   if(Logging)
   {
      if(StringFind(Symbol(),".",0) > 0)
      {
         periodChar = ".";
      }
      else
      {
         pair += ".";
      }
      string audusd = DoubleToStr(MarketInfo("AUDUSD"+periodChar,MODE_ASK));
      string audjpy = DoubleToStr(MarketInfo("AUDJPY"+periodChar,MODE_ASK));
      string euraud = DoubleToStr(MarketInfo("EURAUD"+periodChar,MODE_ASK));
      string gbpaud = DoubleToStr(MarketInfo("GBPAUD"+periodChar,MODE_ASK));
      int handle = FileOpen("SpreadLog_"+pair+"csv", FILE_CSV|FILE_READ|FILE_WRITE,",");
      FileSeek(handle, 0, SEEK_END);
      FileWrite(handle, TimeToStr(TimeCurrent(), TIME_DATE|TIME_SECONDS), spreadValue,Ask,audusd,audjpy,euraud,gbpaud);
      FileClose(handle);
   }
   
//--- return value of prev_calculated for next call
   return(rates_total);
  }
